var assert = require( 'assert' );
var cli = require( '../' );
var fs = require( 'fs' );
var spread = require( '../lib/spread' );
var nfcall = require( '../lib/nfcall' );

require( './suite' );

describe( 'The generate controller', function () {

  it( 'should generate an API policy', function ( done ) {

    cli.dispatch( [ 'generate', 'apiPolicy', 'test/swagger.yaml', 'test/apiproxy' ] )
      .then( describe.ok )
      .then( function () {
        return Promise.all( [
          nfcall( fs.readFile, 'test/apiproxy/resources/jsc/api.js' ),
          nfcall( fs.readFile, 'test/apiproxy/policies/api.xml' ),
        ] );
      } )
      .then( spread( function ( js, policy ) {
        assert.ok( js.toString().match( '"Unicorns"' ) );
        assert.ok( policy.toString().match( '<!-- generated by edge-cli -->' ) );
      } ) )
      .then( cleanup, cleanup )
      .then( done, done );

    function cleanup( err ) {
      return Promise.all( [
        nfcall( fs.unlink, 'test/apiproxy/resources/jsc/api.js' ),
        nfcall( fs.unlink, 'test/apiproxy/policies/api.xml' ),
      ] ).catch( function () {} ).then( function () {
        if ( err ) throw err;
      } );
    }

  } );

} );
